local e=require"luci.passwall.api"
local t=e.appname
local n=e.uci
local c=e.sys
local d=e.finded_com("singbox")
local r=e.finded_com("xray")
local f=e.fs.access("/usr/share/passwall/rules/gfwlist")
local u=e.fs.access("/usr/share/passwall/rules/chnlist")
local l=e.fs.access("/usr/share/passwall/rules/chnroute")
local i=function(t,e,t)
return e:gsub("-",":")
end
m=Map(t)
e.set_apply_on_parse(m)
local h={}
for t,e in ipairs(e.get_valid_nodes())do
h[#h+1]=e
end
local w=function(n,i,a)
local e={}
local o={}
if type(a)=="table"then
local t
for a,t in ipairs(a)do
if t and#t>0 then
if not o[t]then
o[t]=t
e[#e+1]=t
end
end
end
else
e={a}
end
e=table.concat(e," ")
return DynamicList.write(n,i,e)
end
s=m:section(NamedSection,arg[1],translate("ACLs"),translate("ACLs"))
s.addremove=false
s.dynamic=false
o=s:option(Flag,"enabled",translate("Enable"))
o.default=1
o.rmempty=false
o=s:option(Value,"remarks",translate("Remarks"))
o.default=arg[1]
o.rmempty=true
local a={}
c.net.mac_hints(function(t,e)
a[#a+1]={
ip=e,
mac=t
}
end)
table.sort(a,function(t,e)
if#t.ip<#e.ip then
return true
elseif#t.ip==#e.ip then
if t.ip<e.ip then
return true
else
return#t.ip<#e.ip
end
end
return false
end)
sources=s:option(DynamicList,"sources",translate("Source"))
sources.description="<ul><li>"..translate("Example:")
.."</li><li>"..translate("MAC")..": 00:00:00:FF:FF:FF"
.."</li><li>"..translate("IP")..": 192.168.1.100"
.."</li><li>"..translate("IP CIDR")..": 192.168.1.0/24"
.."</li><li>"..translate("IP range")..": 192.168.1.100-192.168.1.200"
.."</li><li>"..translate("IPSet")..": ipset:lanlist"
.."</li></ul>"
sources.cast="string"
for t,e in pairs(a)do
sources:value(e.mac,"%s (%s)"%{e.mac,e.ip})
end
sources.cfgvalue=function(t,a)
local e
if t.tag_error[a]then
e=t:formvalue(a)
else
e=t.map:get(a,t.option)
if type(e)=="string"then
local t={}
string.gsub(e,'[^'.." "..']+',function(e)table.insert(t,e)end)
e=t
end
end
return e
end
sources.validate=function(s,n,i)
local o={}
for t,a in ipairs(n)do
local t=false
if a:find("ipset:")and a:find("ipset:")==1 then
local e=a:gsub("ipset:","")
if e and e~=""then
t=true
end
end
if t==false and datatypes.macaddr(a)then
t=true
end
if t==false and datatypes.ip4addr(a)then
t=true
end
if t==false and e.iprange(a)then
t=true
end
if t==false then
o[#o+1]=a
end
end
if#o>0 then
s:add_error(i,"invalid",translate("Not true format, please re-enter!"))
for t,e in ipairs(o)do
s:add_error(i,"invalid",e)
end
end
return n
end
sources.write=w
tcp_node=s:option(ListValue,"tcp_node","<a style='color: red'>"..translate("TCP Node").."</a>")
tcp_node.default="nil"
tcp_node:value("nil",translate("Close"))
udp_node=s:option(ListValue,"udp_node","<a style='color: red'>"..translate("UDP Node").."</a>")
udp_node.default="nil"
udp_node:value("nil",translate("Close"))
udp_node:value("tcp",translate("Same as the tcp node"))
for t,e in pairs(h)do
tcp_node:value(e.id,e["remark"])
udp_node:value(e.id,e["remark"])
end
local a=n:get(t,"@global_forwarding[0]","tcp_no_redir_ports")
o=s:option(Value,"tcp_no_redir_ports",translate("TCP No Redir Ports"))
o.default="default"
o:value("disable",translate("No patterns are used"))
o:value("default",translate("Use global config").."("..a..")")
o:value("1:65535",translate("All"))
o.validate=i
o:depends({tcp_node="nil",['!reverse']=true})
local a=n:get(t,"@global_forwarding[0]","udp_no_redir_ports")
o=s:option(Value,"udp_no_redir_ports",translate("UDP No Redir Ports"))
o.default="default"
o:value("disable",translate("No patterns are used"))
o:value("default",translate("Use global config").."("..a..")")
o:value("1:65535",translate("All"))
o.validate=i
o:depends({udp_node="nil",['!reverse']=true})
local a=n:get(t,"@global_forwarding[0]","tcp_proxy_drop_ports")
o=s:option(Value,"tcp_proxy_drop_ports",translate("TCP Proxy Drop Ports"))
o.default="default"
o:value("disable",translate("No patterns are used"))
o:value("default",translate("Default"))
o.validate=i
o:value("default",translate("Use global config").."("..a..")")
o:depends({tcp_node="nil",['!reverse']=true})
local a=n:get(t,"@global_forwarding[0]","udp_proxy_drop_ports")
o=s:option(Value,"udp_proxy_drop_ports",translate("UDP Proxy Drop Ports"))
o.default="default"
o:value("disable",translate("No patterns are used"))
o:value("default",translate("Use global config").."("..a..")")
o:value("80,443",translate("QUIC"))
o.validate=i
o:depends({udp_node="nil",['!reverse']=true})
local a=n:get(t,"@global_forwarding[0]","tcp_redir_ports")
o=s:option(Value,"tcp_redir_ports",translate("TCP Redir Ports"))
o.default="default"
o:value("default",translate("Use global config").."("..a..")")
o:value("1:65535",translate("All"))
o:value("80,443","80,443")
o:value("80:65535","80 "..translate("or more"))
o:value("1:443","443 "..translate("or less"))
o.validate=i
o:depends({tcp_node="nil",['!reverse']=true})
local a=n:get(t,"@global_forwarding[0]","udp_redir_ports")
o=s:option(Value,"udp_redir_ports",translate("UDP Redir Ports"))
o.default="default"
o:value("default",translate("Use global config").."("..a..")")
o:value("1:65535",translate("All"))
o:value("53","53")
o.validate=i
o:depends({udp_node="nil",['!reverse']=true})
o=s:option(Flag,"use_direct_list",translatef("Use %s",translate("Direct List")))
o.default="1"
o:depends({tcp_node="nil",['!reverse']=true})
o=s:option(Flag,"use_proxy_list",translatef("Use %s",translate("Proxy List")))
o.default="1"
o:depends({tcp_node="nil",['!reverse']=true})
o=s:option(Flag,"use_block_list",translatef("Use %s",translate("Block List")))
o.default="1"
o:depends({tcp_node="nil",['!reverse']=true})
if f then
o=s:option(Flag,"use_gfw_list",translatef("Use %s",translate("GFW List")))
o.default="1"
o:depends({tcp_node="nil",['!reverse']=true})
end
if u or l then
o=s:option(ListValue,"chn_list",translate("China List"))
o:value("0",translate("Close(Not use)"))
o:value("direct",translate("Direct Connection"))
o:value("proxy",translate("Proxy"))
o.default="direct"
o:depends({tcp_node="nil",['!reverse']=true})
end
o=s:option(ListValue,"tcp_proxy_mode","TCP "..translate("Proxy Mode"))
o:value("disable",translate("No Proxy"))
o:value("proxy",translate("Proxy"))
o:depends({tcp_node="nil",['!reverse']=true})
o=s:option(ListValue,"udp_proxy_mode","UDP "..translate("Proxy Mode"))
o:value("disable",translate("No Proxy"))
o:value("proxy",translate("Proxy"))
o:depends({udp_node="nil",['!reverse']=true})
o=s:option(DummyValue,""," ")
o.template=t.."/global/proxy"
o=s:option(Flag,"filter_proxy_ipv6",translate("Filter Proxy Host IPv6"),translate("Experimental feature."))
o.default="0"
o:depends({tcp_node="nil",['!reverse']=true})
o=s:option(ListValue,"dns_mode",translate("Filter Mode"))
o:depends({tcp_node="nil",['!reverse']=true})
if e.is_finded("dns2socks")then
o:value("dns2socks","dns2socks")
end
if d then
o:value("sing-box","Sing-Box")
end
if r then
o:value("xray","Xray")
end
o=s:option(ListValue,"xray_dns_mode"," ")
o:value("tcp","TCP")
o:value("tcp+doh","TCP + DoH ("..translate("A/AAAA type")..")")
o:depends("dns_mode","xray")
o.cfgvalue=function(t,e)
return m:get(e,"v2ray_dns_mode")
end
o.write=function(a,e,t)
if s.fields["dns_mode"]:formvalue(e)=="xray"then
return m:set(e,"v2ray_dns_mode",t)
end
end
o=s:option(ListValue,"singbox_dns_mode"," ")
o:value("tcp","TCP")
o:value("doh","DoH")
o:depends("dns_mode","sing-box")
o.cfgvalue=function(t,e)
return m:get(e,"v2ray_dns_mode")
end
o.write=function(a,e,t)
if s.fields["dns_mode"]:formvalue(e)=="sing-box"then
return m:set(e,"v2ray_dns_mode",t)
end
end
o=s:option(Value,"remote_dns",translate("Remote DNS"))
o.default="1.1.1.1"
o:value("1.1.1.1","1.1.1.1 (CloudFlare)")
o:value("1.1.1.2","1.1.1.2 (CloudFlare-Security)")
o:value("8.8.4.4","8.8.4.4 (Google)")
o:value("8.8.8.8","8.8.8.8 (Google)")
o:value("9.9.9.9","9.9.9.9 (Quad9-Recommended)")
o:value("208.67.220.220","208.67.220.220 (OpenDNS)")
o:value("208.67.222.222","208.67.222.222 (OpenDNS)")
o:depends({dns_mode="dns2socks"})
o:depends({xray_dns_mode="tcp"})
o:depends({xray_dns_mode="tcp+doh"})
o:depends({singbox_dns_mode="tcp"})
if d or r then
o=s:option(Value,"remote_dns_doh",translate("Remote DNS DoH"))
o:value("https://1.1.1.1/dns-query","CloudFlare")
o:value("https://1.1.1.2/dns-query","CloudFlare-Security")
o:value("https://8.8.4.4/dns-query","Google 8844")
o:value("https://8.8.8.8/dns-query","Google 8888")
o:value("https://9.9.9.9/dns-query","Quad9-Recommended")
o:value("https://208.67.222.222/dns-query","OpenDNS")
o:value("https://dns.adguard.com/dns-query,176.103.130.130","AdGuard")
o:value("https://doh.libredns.gr/dns-query,116.202.176.26","LibreDNS")
o:value("https://doh.libredns.gr/ads,116.202.176.26","LibreDNS (No Ads)")
o.default="https://1.1.1.1/dns-query"
o.validate=function(a,t,a)
if t~=""then
t=e.trim(t)
local o=0
local a=require"luci.util"
local a=a.split(t,",")
local i=a[1]
a[1]=nil
for t=1,#a do
local t=a[t]
if t then
if not e.datatypes.ipmask4(t)then
o=1
end
end
end
if o==0 then
return t
end
end
return nil,translate("DoH request address").." "..translate("Format must be:").." URL,IP"
end
o:depends({xray_dns_mode="tcp+doh"})
o:depends({singbox_dns_mode="doh"})
if r then
o=s:option(Value,"dns_client_ip",translate("EDNS Client Subnet"))
o.datatype="ipaddr"
o:depends({dns_mode="xray"})
end
end
if e.is_finded("chinadns-ng")then
o=s:option(Flag,"chinadns_ng",translate("ChinaDNS-NG"),translate("The effect is better, but will increase the memory."))
o.default="0"
o:depends({use_gfw_list=true})
o:depends({chn_list="direct"})
o=s:option(ListValue,"chinadns_ng_default_tag",translate("ChinaDNS-NG Domain Default Tag"))
o.default="smart"
o:value("smart",translate("Smart DNS"))
o:value("gfw",translate("Remote DNS"))
o:value("chn",translate("Direct DNS"))
o.description="<ul>"
.."<li>"..translate("Forward to both remote and direct DNS, if the direct DNS resolution result is a mainland China ip, then use the direct result, otherwise use the remote result").."</li>"
.."<li>"..translate("Remote DNS can avoid more DNS leaks, but some domestic domain names maybe to proxy!").."</li>"
.."<li>"..translate("Direct DNS Internet experience may be better, but DNS will be leaked!").."</li>"
.."</ul>"
o:depends("chinadns_ng",true)
end
o=s:option(ListValue,"use_default_dns",translate("Default DNS"))
o.default="direct"
o:value("remote",translate("Remote DNS"))
o:value("direct",translate("Direct DNS"))
o.description=translate("The default DNS used when not in the domain name rules list.")
.."<ul>"
.."<li>"..translate("Remote DNS can avoid more DNS leaks, but some domestic domain names maybe to proxy!").."</li>"
.."<li>"..translate("Direct DNS Internet experience may be better, but DNS will be leaked!").."</li>"
.."</ul>"
local t={tcp_proxy_mode="proxy"}
if e.is_finded("chinadns-ng")then
t["chinadns_ng"]=false
end
o:depends(t)
return m
