local i=require"luci.passwall.api"
local h=i.appname
local e=i.fs
local n=i.sys
local t=i.datatypes
local a=string.format("/usr/share/%s/rules/",h)
local r="/etc/"
m=Map(h)
i.set_apply_on_parse(m)
s=m:section(TypedSection,"global_rules")
s.anonymous=true
s:tab("direct_list",translate("Direct List"))
s:tab("proxy_list",translate("Proxy List"))
s:tab("block_list",translate("Block List"))
s:tab("lan_ip_list",translate("Lan IP List"))
s:tab("route_hosts",translate("Route Hosts"))
local i=a.."direct_host"
o=s:taboption("direct_list",TextValue,"direct_host","","<font color='red'>"..translate("Join the direct hosts list of domain names will not proxy.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
n.call("rm -rf /tmp/etc/passwall_tmp/dns_*")
end
o.remove=function(t,t,t)
e.writefile(i,"")
n.call("rm -rf /tmp/etc/passwall_tmp/dns_*")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not t.hostname(e)then
return nil,e.." "..translate("Not valid domain name, please re-enter!")
end
end
return a
end
local i=a.."direct_ip"
o=s:taboption("direct_list",TextValue,"direct_ip","","<font color='red'>"..translate("These had been joined ip addresses will not proxy. Please input the ip address or ip address segment,every line can input only one ip address. For example: 192.168.0.0/24 or 223.5.5.5.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(i,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not(t.ipmask4(e)or t.ipmask6(e))then
return nil,e.." "..translate("Not valid IP format, please re-enter!")
end
end
return a
end
local i=a.."proxy_host"
o=s:taboption("proxy_list",TextValue,"proxy_host","","<font color='red'>"..translate("These had been joined websites will use proxy. Please input the domain names of websites, every line can input only one website domain. For example: google.com.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
n.call("rm -rf /tmp/etc/passwall_tmp/dns_*")
end
o.remove=function(t,t,t)
e.writefile(i,"")
n.call("rm -rf /tmp/etc/passwall_tmp/dns_*")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not t.hostname(e)then
return nil,e.." "..translate("Not valid domain name, please re-enter!")
end
end
return a
end
local i=a.."proxy_ip"
o=s:taboption("proxy_list",TextValue,"proxy_ip","","<font color='red'>"..translate("These had been joined ip addresses will use proxy. Please input the ip address or ip address segment, every line can input only one ip address. For example: 35.24.0.0/24 or 8.8.4.4.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(i,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not(t.ipmask4(e)or t.ipmask6(e))then
return nil,e.." "..translate("Not valid IP format, please re-enter!")
end
end
return a
end
local i=a.."block_host"
o=s:taboption("block_list",TextValue,"block_host","","<font color='red'>"..translate("These had been joined websites will be block. Please input the domain names of websites, every line can input only one website domain. For example: twitter.com.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(i,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not t.hostname(e)then
return nil,e.." "..translate("Not valid domain name, please re-enter!")
end
end
return a
end
local i=a.."block_ip"
o=s:taboption("block_list",TextValue,"block_ip","","<font color='red'>"..translate("These had been joined ip addresses will be block. Please input the ip address or ip address segment, every line can input only one ip address.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(i,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not(t.ipmask4(e)or t.ipmask6(e))then
return nil,e.." "..translate("Not valid IP format, please re-enter!")
end
end
return a
end
local i=a.."lanlist_ipv4"
o=s:taboption("lan_ip_list",TextValue,"lanlist_ipv4","","<font color='red'>"..translate("The list is the IPv4 LAN IP list, which represents the direct connection IP of the LAN. If you need the LAN IP in the proxy list, please clear it from the list. Do not modify this list by default.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(i)or""
end
o.write=function(a,a,t)
e.writefile(i,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(i,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not t.ipmask4(e)then
return nil,e.." "..translate("Not valid IPv4 format, please re-enter!")
end
end
return a
end
local a=a.."lanlist_ipv6"
o=s:taboption("lan_ip_list",TextValue,"lanlist_ipv6","","<font color='red'>"..translate("The list is the IPv6 LAN IP list, which represents the direct connection IP of the LAN. If you need the LAN IP in the proxy list, please clear it from the list. Do not modify this list by default.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)
return e.readfile(a)or""
end
o.write=function(i,i,t)
e.writefile(a,t:gsub("\r\n","\n"))
end
o.remove=function(t,t,t)
e.writefile(a,"")
end
o.validate=function(e,a)
local e={}
string.gsub(a,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for o,e in ipairs(e)do
if e:find("#")and e:find("#")==1 then
return a
end
if not t.ipmask6(e)then
return nil,e.." "..translate("Not valid IPv6 format, please re-enter!")
end
end
return a
end
local t=r.."hosts"
o=s:taboption("route_hosts",TextValue,"hosts","","<font color='red'>"..translate("Configure routing etc/hosts file, if you don't know what you are doing, please don't change the content.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(a,a)
return e.readfile(t)or""
end
o.write=function(i,i,a)
e.writefile(t,a:gsub("\r\n","\n"))
end
o.remove=function(a,a,a)
e.writefile(t,"")
end
if n.call('[ -f "/www/luci-static/resources/uci.js" ]')==0 then
m.apply_on_parse=true
function m.on_apply(e)
luci.sys.call("/etc/init.d/passwall reload > /dev/null 2>&1 &")
end
end
return m
