local e=require"luci.passwall.api"
local t=e.appname
local i=e.datatypes
m=Map(t,"Xray "..translate("Shunt Rule"))
m.redirect=e.url()
e.set_apply_on_parse(m)
s=m:section(NamedSection,arg[1],"shunt_rules","")
s.addremove=false
s.dynamic=false
remarks=s:option(Value,"remarks",translate("Remarks"))
remarks.default=arg[1]
remarks.rmempty=false
protocol=s:option(MultiValue,"protocol",translate("Protocol"))
protocol:value("http")
protocol:value("tls")
protocol:value("bittorrent")
o=s:option(MultiValue,"inbound",translate("Inbound Tag"))
o:value("tproxy",translate("Transparent proxy"))
o:value("socks","Socks")
network=s:option(ListValue,"network",translate("Network"))
network:value("tcp,udp","TCP UDP")
network:value("tcp","TCP")
network:value("udp","UDP")
source=s:option(DynamicList,"source",translate("Source"))
source.description="<ul><li>"..translate("Example:")
.."</li><li>"..translate("IP")..": 192.168.1.100"
.."</li><li>"..translate("IP CIDR")..": 192.168.1.0/24"
.."</li><li>"..translate("GeoIP")..": geoip:private"
.."</li></ul>"
source.cast="string"
source.cfgvalue=function(t,a)
local e
if t.tag_error[a]then
e=t:formvalue(a)
else
e=t.map:get(a,t.option)
if type(e)=="string"then
local t={}
string.gsub(e,'[^'.." "..']+',function(e)table.insert(t,e)end)
e=t
end
end
return e
end
source.validate=function(s,n,o)
local a={}
for t,e in ipairs(n)do
local t=false
if i.ip4addr(e)then
t=true
end
if t==false and e:find("geoip:")and e:find("geoip:")==1 then
t=true
end
if t==false then
a[#a+1]=e
end
end
if#a>0 then
s:add_error(o,"invalid",translate("Not true format, please re-enter!"))
for t,e in ipairs(a)do
s:add_error(o,"invalid",e)
end
end
return n
end
local e=function(n,i,a)
local e={}
local o={}
if type(a)=="table"then
local t
for a,t in ipairs(a)do
if t and#t>0 then
if not o[t]then
o[t]=t
e[#e+1]=t
end
end
end
else
e={a}
end
e=table.concat(e," ")
return DynamicList.write(n,i,e)
end
source.write=e
port=s:option(Value,"port",translate("port"))
domain_list=s:option(TextValue,"domain_list",translate("Domain"))
domain_list.rows=10
domain_list.wrap="off"
domain_list.validate=function(e,o)
local e={}
string.gsub(o,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for t,e in ipairs(e)do
local t=1
local a=e
if e:find("regexp:")and e:find("regexp:")==1 then
t=0
elseif e:find("domain:.")and e:find("domain:.")==1 then
a=e:gsub("domain:","")
elseif e:find("full:.")and e:find("full:.")==1 then
a=e:gsub("full:","")
elseif e:find("geosite:")and e:find("geosite:")==1 then
t=0
elseif e:find("ext:")and e:find("ext:")==1 then
t=0
end
if t==1 then
if not i.hostname(a)then
return nil,a.." "..translate("Not valid domain name, please re-enter!")
end
end
end
return o
end
domain_list.description="<br /><ul><li>"..translate("Plaintext: If this string matches any part of the targeting domain, this rule takes effet. Example: rule 'sina.com' matches targeting domain 'sina.com', 'sina.com.cn' and 'www.sina.com', but not 'sina.cn'.")
.."</li><li>"..translate("Regular expression: Begining with 'regexp:', the rest is a regular expression. When the regexp matches targeting domain, this rule takes effect. Example: rule 'regexp:\\.goo.*\\.com$' matches 'www.google.com' and 'fonts.googleapis.com', but not 'google.com'.")
.."</li><li>"..translate("Subdomain (recommended): Begining with 'domain:' and the rest is a domain. When the targeting domain is exactly the value, or is a subdomain of the value, this rule takes effect. Example: rule 'domain:v2ray.com' matches 'www.v2ray.com', 'v2ray.com', but not 'xv2ray.com'.")
.."</li><li>"..translate("Full domain: Begining with 'full:' and the rest is a domain. When the targeting domain is exactly the value, the rule takes effect. Example: rule 'domain:v2ray.com' matches 'v2ray.com', but not 'www.v2ray.com'.")
.."</li><li>"..translate("Pre-defined domain list: Begining with 'geosite:' and the rest is a name, such as geosite:google or geosite:cn.")
.."</li><li>"..translate("Domains from file: Such as 'ext:file:tag'. The value must begin with ext: (lowercase), and followed by filename and tag. The file is placed in resource directory, and has the same format of geosite.dat. The tag must exist in the file.")
.."</li></ul>"
ip_list=s:option(TextValue,"ip_list","IP")
ip_list.rows=10
ip_list.wrap="off"
ip_list.validate=function(e,t)
local e={}
string.gsub(t,'[^'.."\r\n"..']+',function(t)table.insert(e,t)end)
for t,e in ipairs(e)do
if e:find("geoip:")and e:find("geoip:")==1 then
elseif e:find("ext:")and e:find("ext:")==1 then
else
if not(i.ipmask4(e)or i.ipmask6(e))then
return nil,e.." "..translate("Not valid IP format, please re-enter!")
end
end
end
return t
end
ip_list.description="<br /><ul><li>"..translate("IP: such as '127.0.0.1'.")
.."</li><li>"..translate("CIDR: such as '127.0.0.0/8'.")
.."</li><li>"..translate("GeoIP: such as 'geoip:cn'. It begins with geoip: (lower case) and followed by two letter of country code.")
.."</li><li>"..translate("IPs from file: Such as 'ext:file:tag'. The value must begin with ext: (lowercase), and followed by filename and tag. The file is placed in resource directory, and has the same format of geoip.dat. The tag must exist in the file.")
.."</li></ul>"
return m
