local u,a=...
local n=require"luci.passwall.api"
if not n.finded_com("xray")then
return
end
local f=n.appname
local i=n.uci
local r="Xray"
local d="xray_"
local function t(e)
return d..e
end
local c={
"aes-128-gcm","aes-256-gcm","chacha20-poly1305","xchacha20-poly1305","2022-blake3-aes-128-gcm","2022-blake3-aes-256-gcm","2022-blake3-chacha20-poly1305"
}
local m={"none","auto","aes-128-gcm","chacha20-poly1305","zero"}
local l={
"none","srtp","utp","wechat-video","dtls","wireguard"
}
a.fields["type"]:value(r,"Xray")
o=a:option(ListValue,t("protocol"),translate("Protocol"))
o:value("vmess",translate("Vmess"))
o:value("vless",translate("VLESS"))
o:value("http",translate("HTTP"))
o:value("socks",translate("Socks"))
o:value("shadowsocks",translate("Shadowsocks"))
o:value("trojan",translate("Trojan"))
o:value("wireguard",translate("WireGuard"))
o:value("_balancing",translate("Balancing"))
o:value("_shunt",translate("Shunt"))
o:value("_iface",translate("Custom Interface"))
o=a:option(Value,t("iface"),translate("Interface"))
o.default="eth1"
o:depends({[t("protocol")]="_iface"})
local o={}
local s={}
local h={}
for t,e in ipairs(n.get_valid_nodes())do
if e.node_type=="normal"then
o[#o+1]={
id=e[".name"],
remarks=e["remark"],
type=e["type"]
}
end
if e.protocol=="_balancing"then
s[#s+1]={
id=e[".name"],
remarks=e["remark"]
}
end
if e.protocol=="_iface"then
h[#h+1]={
id=e[".name"],
remarks=e["remark"]
}
end
end
local e=a:option(DynamicList,t("balancing_node"),translate("Load balancing node list"),translate("Load balancing node list, <a target='_blank' href='https://toutyrater.github.io/routing/balance2.html'>document</a>"))
e:depends({[t("protocol")]="_balancing"})
for a,t in pairs(o)do e:value(t.id,t.remarks)end
local e=a:option(ListValue,t("balancingStrategy"),translate("Balancing Strategy"))
e:depends({[t("protocol")]="_balancing"})
e:value("random")
e:value("leastPing")
e:value("leastLoad")
e.default="leastLoad"
local e=a:option(Flag,t("useCustomProbeUrl"),translate("Use Custome Probe URL"),translate("By default the built-in probe URL will be used, enable this option to use a custom probe URL."))
e:depends({[t("balancingStrategy")]="leastPing"})
e:depends({[t("balancingStrategy")]="leastLoad"})
local e=a:option(Value,t("probeUrl"),translate("Probe URL"))
e:depends({[t("useCustomProbeUrl")]=true})
e.default="https://www.google.com/generate_204"
e.description=translate("The URL used to detect the connection status.")
local e=a:option(Value,t("probeInterval"),translate("Probe Interval"))
e:depends({[t("balancingStrategy")]="leastPing"})
e:depends({[t("balancingStrategy")]="leastLoad"})
e.default="1m"
e.description=translate("The interval between initiating probes. Every time this time elapses, a server status check is performed on a server. The time format is numbers + units, such as '10s', '2h45m', and the supported time units are <code>ns</code>, <code>us</code>, <code>ms</code>, <code>s</code>, <code>m</code>, <code>h</code>, which correspond to nanoseconds, microseconds, milliseconds, seconds, minutes, and hours, respectively.")
if#o>0 then
e=a:option(Flag,t("preproxy_enabled"),translate("Preproxy"))
e:depends({[t("protocol")]="_shunt"})
e=a:option(Value,t("main_node"),string.format('<a style="color:red">%s</a>',translate("Preproxy Node")),translate("Set the node to be used as a pre-proxy. Each rule (including <code>Default</code>) has a separate switch that controls whether this rule uses the pre-proxy or not."))
e:depends({[t("protocol")]="_shunt",[t("preproxy_enabled")]=true})
for a,t in pairs(s)do
e:value(t.id,t.remarks)
end
for a,t in pairs(h)do
e:value(t.id,t.remarks)
end
for a,t in pairs(o)do
e:value(t.id,t.remarks)
end
e.default="nil"
end
i:foreach(f,"shunt_rules",function(i)
if i[".name"]and i.remarks then
e=a:option(Value,t(i[".name"]),string.format('* <a href="%s" target="_blank">%s</a>',n.url("shunt_rules",i[".name"]),i.remarks))
e:value("nil",translate("Close"))
e:value("_default",translate("Default"))
e:value("_direct",translate("Direct Connection"))
e:value("_blackhole",translate("Blackhole"))
e:depends({[t("protocol")]="_shunt"})
if#o>0 then
for a,t in pairs(s)do
e:value(t.id,t.remarks)
end
for a,t in pairs(h)do
e:value(t.id,t.remarks)
end
local a=a:option(ListValue,t(i[".name"].."_proxy_tag"),string.format('* <a style="color:red">%s</a>',i.remarks.." "..translate("Preproxy")))
a:value("nil",translate("Close"))
a:value("main",translate("Preproxy Node"))
a.default="nil"
for n,o in pairs(o)do
e:value(o.id,o.remarks)
a:depends({[t("protocol")]="_shunt",[t("preproxy_enabled")]=true,[t(i[".name"])]=o.id})
end
end
end
end)
e=a:option(DummyValue,t("shunt_tips")," ")
e.not_rewrite=true
e.rawhtml=true
e.cfgvalue=function(t,t)
return string.format('<a style="color: red" href="../rule">%s</a>',translate("No shunt rules? Click me to go to add."))
end
e:depends({[t("protocol")]="_shunt"})
local e=a:option(Value,t("default_node"),string.format('* <a style="color:red">%s</a>',translate("Default")))
e:depends({[t("protocol")]="_shunt"})
e:value("_direct",translate("Direct Connection"))
e:value("_blackhole",translate("Blackhole"))
if#o>0 then
for a,t in pairs(s)do
e:value(t.id,t.remarks)
end
for a,t in pairs(h)do
e:value(t.id,t.remarks)
end
local a=a:option(ListValue,t("default_proxy_tag"),string.format('* <a style="color:red">%s</a>',translate("Default Preproxy")),translate("When using, localhost will connect this node first and then use this node to connect the default node."))
a:value("nil",translate("Close"))
a:value("main",translate("Preproxy Node"))
a.default="nil"
for i,o in pairs(o)do
e:value(o.id,o.remarks)
a:depends({[t("protocol")]="_shunt",[t("preproxy_enabled")]=true,[t("default_node")]=o.id})
end
end
e=a:option(ListValue,t("domainStrategy"),translate("Domain Strategy"))
e:value("AsIs")
e:value("IPIfNonMatch")
e:value("IPOnDemand")
e.default="IPOnDemand"
e.description="<br /><ul><li>"..translate("'AsIs': Only use domain for routing. Default value.")
.."</li><li>"..translate("'IPIfNonMatch': When no rule matches current domain, resolves it into IP addresses (A or AAAA records) and try all rules again.")
.."</li><li>"..translate("'IPOnDemand': As long as there is a IP-based rule, resolves the domain into IP immediately.")
.."</li></ul>"
e:depends({[t("protocol")]="_shunt"})
e=a:option(ListValue,t("domainMatcher"),translate("Domain matcher"))
e:value("hybrid")
e:value("linear")
e:depends({[t("protocol")]="_shunt"})
e=a:option(Value,t("address"),translate("Address (Support Domain Name)"))
e=a:option(Value,t("port"),translate("Port"))
e.datatype="port"
local i=a.fields[t("protocol")].keylist
if#i>0 then
for o,e in ipairs(i)do
if not e:find("_")then
a.fields[t("address")]:depends({[t("protocol")]=e})
a.fields[t("port")]:depends({[t("protocol")]=e})
end
end
end
e=a:option(Value,t("username"),translate("Username"))
e:depends({[t("protocol")]="http"})
e:depends({[t("protocol")]="socks"})
e=a:option(Value,t("password"),translate("Password"))
e.password=true
e:depends({[t("protocol")]="http"})
e:depends({[t("protocol")]="socks"})
e:depends({[t("protocol")]="shadowsocks"})
e:depends({[t("protocol")]="trojan"})
e=a:option(ListValue,t("security"),translate("Encrypt Method"))
for a,t in ipairs(m)do e:value(t)end
e:depends({[t("protocol")]="vmess"})
e=a:option(Value,t("encryption"),translate("Encrypt Method"))
e.default="none"
e:value("none")
e:depends({[t("protocol")]="vless"})
e=a:option(ListValue,t("x_ss_encrypt_method"),translate("Encrypt Method"))
e.rewrite_option="method"
for a,t in ipairs(c)do e:value(t)end
e:depends({[t("protocol")]="shadowsocks"})
e=a:option(Flag,t("iv_check"),translate("IV Check"))
e:depends({[t("protocol")]="shadowsocks",[t("x_ss_encrypt_method")]="aes-128-gcm"})
e:depends({[t("protocol")]="shadowsocks",[t("x_ss_encrypt_method")]="aes-256-gcm"})
e:depends({[t("protocol")]="shadowsocks",[t("x_ss_encrypt_method")]="chacha20-poly1305"})
e:depends({[t("protocol")]="shadowsocks",[t("x_ss_encrypt_method")]="xchacha20-poly1305"})
e=a:option(Flag,t("uot"),translate("UDP over TCP"))
e:depends({[t("protocol")]="shadowsocks"})
e=a:option(Value,t("uuid"),translate("ID"))
e.password=true
e:depends({[t("protocol")]="vmess"})
e:depends({[t("protocol")]="vless"})
e=a:option(ListValue,t("flow"),translate("flow"))
e.default=""
e:value("",translate("Disable"))
e:value("xtls-rprx-vision")
e:depends({[t("protocol")]="vless",[t("tls")]=true,[t("transport")]="tcp"})
e=a:option(Flag,t("tls"),translate("TLS"))
e.default=0
e:depends({[t("protocol")]="vmess"})
e:depends({[t("protocol")]="vless"})
e:depends({[t("protocol")]="http"})
e:depends({[t("protocol")]="socks"})
e:depends({[t("protocol")]="trojan"})
e:depends({[t("protocol")]="shadowsocks"})
e=a:option(Flag,t("reality"),translate("REALITY"),translate("Only recommend to use with VLESS-TCP-XTLS-Vision."))
e.default=0
e:depends({[t("tls")]=true,[t("transport")]="tcp"})
e:depends({[t("tls")]=true,[t("transport")]="h2"})
e:depends({[t("tls")]=true,[t("transport")]="grpc"})
e=a:option(ListValue,t("alpn"),translate("alpn"))
e.default="default"
e:value("default",translate("Default"))
e:value("h2,http/1.1")
e:value("h2")
e:value("http/1.1")
e:depends({[t("tls")]=true,[t("reality")]=false})
e=a:option(Value,t("tls_serverName"),translate("Domain"))
e:depends({[t("tls")]=true})
e=a:option(Flag,t("tls_allowInsecure"),translate("allowInsecure"),translate("Whether unsafe connections are allowed. When checked, Certificate validation will be skipped."))
e.default="0"
e:depends({[t("tls")]=true,[t("reality")]=false})
e=a:option(Value,t("reality_publicKey"),translate("Public Key"))
e:depends({[t("tls")]=true,[t("reality")]=true})
e=a:option(Value,t("reality_shortId"),translate("Short Id"))
e:depends({[t("tls")]=true,[t("reality")]=true})
e=a:option(Value,t("reality_spiderX"),translate("Spider X"))
e.placeholder="/"
e:depends({[t("tls")]=true,[t("reality")]=true})
e=a:option(Flag,t("utls"),translate("uTLS"))
e.default="0"
e:depends({[t("tls")]=true,[t("reality")]=false})
e=a:option(ListValue,t("fingerprint"),translate("Finger Print"))
e:value("chrome")
e:value("firefox")
e:value("edge")
e:value("safari")
e:value("360")
e:value("qq")
e:value("ios")
e:value("android")
e:value("random")
e:value("randomized")
e.default="chrome"
e:depends({[t("tls")]=true,[t("utls")]=true})
e:depends({[t("tls")]=true,[t("reality")]=true})
e=a:option(ListValue,t("transport"),translate("Transport"))
e:value("tcp","TCP")
e:value("mkcp","mKCP")
e:value("ws","WebSocket")
e:value("h2","HTTP/2")
e:value("ds","DomainSocket")
e:value("quic","QUIC")
e:value("grpc","gRPC")
e:depends({[t("protocol")]="vmess"})
e:depends({[t("protocol")]="vless"})
e:depends({[t("protocol")]="socks"})
e:depends({[t("protocol")]="shadowsocks"})
e:depends({[t("protocol")]="trojan"})
e=a:option(Value,t("wireguard_public_key"),translate("Public Key"))
e:depends({[t("protocol")]="wireguard"})
e=a:option(Value,t("wireguard_secret_key"),translate("Private Key"))
e:depends({[t("protocol")]="wireguard"})
e=a:option(Value,t("wireguard_preSharedKey"),translate("Pre shared key"))
e:depends({[t("protocol")]="wireguard"})
e=a:option(DynamicList,t("wireguard_local_address"),translate("Local Address"))
e:depends({[t("protocol")]="wireguard"})
e=a:option(Value,t("wireguard_mtu"),translate("MTU"))
e.default="1420"
e:depends({[t("protocol")]="wireguard"})
if n.compare_versions(n.get_app_version("xray"),">=","1.8.0")then
e=a:option(Value,t("wireguard_reserved"),translate("Reserved"),translate("Decimal numbers separated by \",\" or Base64-encoded strings."))
e:depends({[t("protocol")]="wireguard"})
end
e=a:option(Value,t("wireguard_keepAlive"),translate("Keep Alive"))
e.default="0"
e:depends({[t("protocol")]="wireguard"})
e=a:option(ListValue,t("tcp_guise"),translate("Camouflage Type"))
e:value("none","none")
e:value("http","http")
e:depends({[t("transport")]="tcp"})
e=a:option(DynamicList,t("tcp_guise_http_host"),translate("HTTP Host"))
e:depends({[t("tcp_guise")]="http"})
e=a:option(DynamicList,t("tcp_guise_http_path"),translate("HTTP Path"))
e.placeholder="/"
e:depends({[t("tcp_guise")]="http"})
e=a:option(ListValue,t("mkcp_guise"),translate("Camouflage Type"),translate('<br />none: default, no masquerade, data sent is packets with no characteristics.<br />srtp: disguised as an SRTP packet, it will be recognized as video call data (such as FaceTime).<br />utp: packets disguised as uTP will be recognized as bittorrent downloaded data.<br />wechat-video: packets disguised as WeChat video calls.<br />dtls: disguised as DTLS 1.2 packet.<br />wireguard: disguised as a WireGuard packet. (not really WireGuard protocol)'))
for a,t in ipairs(l)do e:value(t)end
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_mtu"),translate("KCP MTU"))
e.default="1350"
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_tti"),translate("KCP TTI"))
e.default="20"
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_uplinkCapacity"),translate("KCP uplinkCapacity"))
e.default="5"
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_downlinkCapacity"),translate("KCP downlinkCapacity"))
e.default="20"
e:depends({[t("transport")]="mkcp"})
e=a:option(Flag,t("mkcp_congestion"),translate("KCP Congestion"))
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_readBufferSize"),translate("KCP readBufferSize"))
e.default="1"
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_writeBufferSize"),translate("KCP writeBufferSize"))
e.default="1"
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("mkcp_seed"),translate("KCP Seed"))
e:depends({[t("transport")]="mkcp"})
e=a:option(Value,t("ws_host"),translate("WebSocket Host"))
e:depends({[t("transport")]="ws"})
e:depends({[t("ss_transport")]="ws"})
e=a:option(Value,t("ws_path"),translate("WebSocket Path"))
e.placeholder="/"
e:depends({[t("transport")]="ws"})
e:depends({[t("ss_transport")]="ws"})
e=a:option(Value,t("h2_host"),translate("HTTP/2 Host"))
e:depends({[t("transport")]="h2"})
e:depends({[t("ss_transport")]="h2"})
e=a:option(Value,t("h2_path"),translate("HTTP/2 Path"))
e.placeholder="/"
e:depends({[t("transport")]="h2"})
e:depends({[t("ss_transport")]="h2"})
e=a:option(Flag,t("h2_health_check"),translate("Health check"))
e:depends({[t("transport")]="h2"})
e=a:option(Value,t("h2_read_idle_timeout"),translate("Idle timeout"))
e.default="10"
e:depends({[t("h2_health_check")]=true})
e=a:option(Value,t("h2_health_check_timeout"),translate("Health check timeout"))
e.default="15"
e:depends({[t("h2_health_check")]=true})
e=a:option(Value,t("ds_path"),"Path",translate("A legal file path. This file must not exist before running."))
e:depends({[t("transport")]="ds"})
e=a:option(ListValue,t("quic_security"),translate("Encrypt Method"))
e:value("none")
e:value("aes-128-gcm")
e:value("chacha20-poly1305")
e:depends({[t("transport")]="quic"})
e=a:option(Value,t("quic_key"),translate("Encrypt Method")..translate("Key"))
e:depends({[t("transport")]="quic"})
e=a:option(ListValue,t("quic_guise"),translate("Camouflage Type"))
for a,t in ipairs(l)do e:value(t)end
e:depends({[t("transport")]="quic"})
e=a:option(Value,t("grpc_serviceName"),"ServiceName")
e:depends({[t("transport")]="grpc"})
e=a:option(ListValue,t("grpc_mode"),"gRPC "..translate("Transfer mode"))
e:value("gun")
e:value("multi")
e:depends({[t("transport")]="grpc"})
e=a:option(Flag,t("grpc_health_check"),translate("Health check"))
e:depends({[t("transport")]="grpc"})
e=a:option(Value,t("grpc_idle_timeout"),translate("Idle timeout"))
e.default="10"
e:depends({[t("grpc_health_check")]=true})
e=a:option(Value,t("grpc_health_check_timeout"),translate("Health check timeout"))
e.default="20"
e:depends({[t("grpc_health_check")]=true})
e=a:option(Flag,t("grpc_permit_without_stream"),translate("Permit without stream"))
e.default="0"
e:depends({[t("grpc_health_check")]=true})
e=a:option(Value,t("grpc_initial_windows_size"),translate("Initial Windows Size"))
e.default="0"
e:depends({[t("transport")]="grpc"})
e=a:option(Flag,t("mux"),translate("Mux"))
e:depends({[t("protocol")]="vmess"})
e:depends({[t("protocol")]="vless",[t("flow")]=""})
e:depends({[t("protocol")]="http"})
e:depends({[t("protocol")]="socks"})
e:depends({[t("protocol")]="shadowsocks"})
e:depends({[t("protocol")]="trojan"})
e=a:option(Value,t("mux_concurrency"),translate("Mux concurrency"))
e.default=8
e:depends({[t("mux")]=true})
e=a:option(Flag,t("xmux"),translate("xMux"))
e.default=1
e:depends({[t("protocol")]="vless",[t("flow")]="xtls-rprx-vision"})
e=a:option(Value,t("xudp_concurrency"),translate("XUDP Mux concurrency"))
e.default=8
e:depends({[t("xmux")]=true})
e=a:option(Flag,t("tcpMptcp"),"tcpMptcp",translate("Enable Multipath TCP, need to be enabled in both server and client configuration."))
e.default=0
e=a:option(Flag,t("tcpNoDelay"),"tcpNoDelay")
e.default=0
e=a:option(ListValue,t("to_node"),translate("Landing node"),translate("Only support a layer of proxy."))
e.default=""
e:value("",translate("Close(Not use)"))
for a,t in pairs(o)do
if t.type=="Xray"then
e:value(t.id,t.remarks)
end
end
for o,e in ipairs(a.fields[t("protocol")].keylist)do
if not e:find("_")then
a.fields[t("tcpMptcp")]:depends({[t("protocol")]=e})
a.fields[t("tcpNoDelay")]:depends({[t("protocol")]=e})
a.fields[t("to_node")]:depends({[t("protocol")]=e})
end
end
n.luci_types(arg[1],u,a,r,d)
