module("luci.passwall.api",package.seeall)
local t=require"luci.passwall.com"
bin=require"nixio".bin
fs=require"nixio.fs"
sys=require"luci.sys"
uci=require"luci.model.uci".cursor()
util=require"luci.util"
datatypes=require"luci.cbi.datatypes"
jsonc=require"luci.jsonc"
i18n=require"luci.i18n"
appname="passwall"
curl_args={"-skfL","--connect-timeout 3","--retry 3","-m 60"}
command_timeout=300
OPENWRT_ARCH=nil
DISTRIB_ARCH=nil
LOG_FILE="/tmp/log/"..appname..".log"
CACHE_PATH="/tmp/etc/"..appname.."_tmp"
function log(...)
local a=os.date("%Y-%m-%d %H:%M:%S: ")..table.concat({...}," ")
local e,t=io.open(LOG_FILE,"a")
if e and t==nil then
e:write(a.."\n")
e:close()
end
end
function exec_call(e)
local o=io.popen(e..'; echo -e "\n$?"')
local e={}
local t=""
local a
for t in o:lines()do
e[#e+1]=t
end
o:close()
if#e>0 then
a=e[#e]
for a=1,#e-1 do
t=t..e[a]..((a==#e-1)and""or"\n")
end
end
return tonumber(a),trim(t)
end
function base64Decode(e)
local t=e
if not e then return''end
e=e:gsub("%z","")
e=e:gsub("%c","")
e=e:gsub("_","/")
e=e:gsub("-","+")
local a=#e%4
e=e..string.sub('====',a+1)
local e=nixio.bin.b64decode(e)
if e then
return e:gsub("%z","")
else
return t
end
end
function curl_base(a,t,e)
if not e then e={}end
if t then
e[#e+1]="-o "..t
end
local e=string.format('curl %s "%s"',table_join(e),a)
return exec_call(e)
end
function curl_proxy(o,a,e)
local t=luci.sys.exec("[ -f /tmp/etc/passwall/TCP_SOCKS_server ] && echo -n $(cat /tmp/etc/passwall/TCP_SOCKS_server) || echo -n ''")
if t~=""then
if not e then e={}end
local e=clone(e)
e[#e+1]="-x socks5h://"..t
return curl_base(o,a,e)
end
return nil,nil
end
function curl_logic(i,o,t)
local e,a=curl_proxy(i,o,t)
if not e or e~=0 then
e,a=curl_base(i,o,t)
end
return e,a
end
function url(...)
local e=string.format("admin/services/%s",appname)
local t={...}
for a,t in pairs(t)do
if t~=""then
e=e.."/"..t
end
end
return require"luci.dispatcher".build_url(e)
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function split(e,o)
if e then
e=e:gsub("%z","")
local t,a=1,{}
while true do
local i,o=e:find(o,t)
if not o then
local e=string.sub(e,t,string.len(e))
if#e>0 then
table.insert(a,e)
end
break
else
table.insert(a,string.sub(e,t,i-1))
t=o+1
end
end
return a
end
return{}
end
function is_exist(e,t)
for a,e in ipairs(e)do
if e==t then
return true
end
end
return false
end
function repeat_exist(t,a)
local e=0
for o,t in ipairs(t)do
if t:find("-")and t==a then
e=e+1
end
end
if e>1 then
return true
end
return false
end
function remove(...)
for t,e in ipairs({...})do
if e and#e>0 and e~="/"then
sys.call(string.format("rm -rf %s",e))
end
end
end
function is_install(e)
if e and#e>0 then
return sys.call(string.format('opkg list-installed | grep "%s" > /dev/null 2>&1',e))==0
end
return false
end
function get_args(e)
local a={}
for t,o in pairs(e)do
if t>0 then
local t=e[t+1]
if t then
if repeat_exist(e,t)==false then
a[o]=t
end
end
end
end
return a
end
function get_function_args(e)
local a=nil
if e and#e>1 then
local t={}
for o=2,#e do
t[#t+1]=e[o]
end
a=get_args(t)
end
return a
end
function strToTable(e)
if e==nil or type(e)~="string"then
return{}
end
return loadstring("return "..e)()
end
function is_normal_node(e)
if e and e.type and e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
return false
end
return true
end
function is_special_node(e)
return is_normal_node(e)==false
end
function is_ip(e)
if is_ipv6(e)then
e=get_ipv6_only(e)
end
return datatypes.ipaddr(e)
end
function is_ipv6(t)
local e=t
local t=t:match('%[(.*)%]')
if t then
e=t
end
if datatypes.ip6addr(e)then
return true
end
return false
end
function is_ipv6addrport(e)
if is_ipv6(e)then
local t,e=e:match('%[(.*)%]:([^:]+)$')
if e then
return datatypes.port(e)
end
end
return false
end
function get_ipv6_only(e)
local t=""
if is_ipv6(e)then
t=e
if e:match('%[(.*)%]')then
t=e:match('%[(.*)%]')
end
end
return t
end
function get_ipv6_full(t)
local e=""
if is_ipv6(t)then
e=t
if not t:match('%[(.*)%]')then
e="["..e.."]"
end
end
return e
end
function get_ip_type(e)
if is_ipv6(e)then
return"6"
elseif datatypes.ip4addr(e)then
return"4"
end
return""
end
function is_mac(e)
return datatypes.macaddr(e)
end
function ip_or_mac(e)
if e then
if get_ip_type(e)=="4"then
return"ip"
end
if is_mac(e)then
return"mac"
end
end
return""
end
function iprange(e)
if e then
local e,t=e:match("^([^/]+)-([^/]+)$")
if(e and datatypes.ip4addr(e))and(t and datatypes.ip4addr(t))then
return true
end
end
return false
end
function get_domain_from_url(t)
local e=string.match(t,"//([^/]+)")
if e then
return e
end
return t
end
function get_valid_nodes()
local i=uci_get_type("global_other","show_node_info")or"0"
local o={}
uci:foreach(appname,"nodes",function(e)
e.id=e[".name"]
if e.type and e.remarks then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
e["remark"]="%s：[%s] "%{e.type.." "..i18n.translatef(e.protocol),e.remarks}
e["node_type"]="special"
o[#o+1]=e
end
if e.port and e.address then
local t=e.address
if is_ip(t)or datatypes.hostname(t)then
local a=e.type
if(a=="sing-box"or a=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
if is_ipv6(t)then t=get_ipv6_full(t)end
e["remark"]="%s：[%s]"%{a,e.remarks}
if i=="1"then
e["remark"]="%s：[%s] %s:%s"%{a,e.remarks,t,e.port}
end
e.node_type="normal"
o[#o+1]=e
end
end
end
end)
return o
end
function get_node_remarks(e)
local t=""
if e then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
t="%s：[%s] "%{e.type.." "..i18n.translatef(e.protocol),e.remarks}
else
local a=e.type
if(e.type=="sing-box"or e.type=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
t="%s：[%s]"%{a,e.remarks}
end
end
return t
end
function get_full_node_remarks(e)
local t=get_node_remarks(e)
if#t>0 then
if e.address and e.port then
t=t.." "..e.address..":"..e.port
end
end
return t
end
function gen_uuid(t)
local e=sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")
if t==nil then
e=string.gsub(e,"-","")
end
return e
end
function gen_short_uuid()
return sys.exec("echo -n $(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 8)")
end
function uci_get_type(a,e,t)
local e=uci:get_first(appname,a,e,t)or sys.exec("echo -n $(uci -q get "..appname..".@"..a.."[0]."..e..")")
if(e==nil or e=="")and(t and t~="")then
e=t
end
return e
end
function uci_get_type_id(a,e,t)
local e=uci:get(appname,a,e,t)or sys.exec("echo -n $(uci -q get "..appname.."."..a.."."..e..")")
if(e==nil or e=="")and(t and t~="")then
e=t
end
return e
end
local function i(e)
if e and e~=""then
if not fs.access(e,"rwx","rx","rx")then
fs.chmod(e,755)
end
end
end
function get_customed_path(e)
return uci_get_type("global_app",e.."_file")
end
function finded_com(e)
local e=get_app_path(e)
if not e then return end
local e=luci.sys.exec('echo -n $(type -t -p "%s" | head -n1)'%{e})
if e==""then
e=nil
end
return e
end
function finded(e)
return luci.sys.exec('echo -n $(type -t -p "/bin/%s" -p "/usr/bin/%s" "%s" | head -n1)'%{e,e,e})
end
function is_finded(e)
return finded(e)~=""and true or false
end
function clone(i)
local function o(e,a)
for t,e in pairs(e)do
if type(e)~="table"then
a[t]=e;
else
a[t]={};
o(e,a[t])
end
end
end
local e={}
o(i,e)
return e
end
local function o(e,a)
sys.call("mkdir -p /tmp/etc/passwall_tmp")
if fs.access(e)then
i(e)
local t=sys.exec("echo -n $(md5sum "..e.." | awk '{print $1}')")
if fs.access("/tmp/etc/passwall_tmp/"..t)then
return sys.exec("echo -n $(cat /tmp/etc/passwall_tmp/%s)"%t)
else
local e=sys.exec(string.format("echo -n $(%s %s)",e,a))
if e and e~=""then
sys.call("echo '"..e.."' > ".."/tmp/etc/passwall_tmp/"..t)
return e
end
end
end
return""
end
function get_app_path(e)
if t[e]then
local t=t[e].default_path
local e=uci_get_type("global_app",e:gsub("%-","_").."_file")
e=e and(#e>0 and e or t)or t
return e
end
end
function get_app_version(a,e)
if e==nil then e=get_app_path(a)end
return o(e,t[a].cmd_version)
end
local function e(e)
if e and#e>1 then
if sys.exec('[ -f "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function a(e)
if e and#e>1 then
if sys.exec('[ -d "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function l(e)
if a(e)then
return e
else
return l(fs.dirname(e))
end
end
local function r(e)
if e==nil then e="/"end
if sys.call("df -k "..e.." >/dev/null 2>&1")==0 then
return tonumber(sys.exec("echo -n $(df -k "..e.." | awk 'NR>1' | awk '{print $4}')"))
end
return 0
end
local function d(e)
if e==nil then return 0 end
if fs.access(e)then
return tonumber(sys.exec("echo -n $(du -k "..e.." | awk '{print $1}')"))
end
return 0
end
function _unpack(t,e)
e=e or 1
if t[e]~=nil then return t[e],_unpack(t,e+1)end
end
function table_join(e,t)
if not t then
t=" "
end
local a=""
for o,i in ipairs(e)do
a=a..e[o]..(o==#e and""or t)
end
return a
end
local function i(h,r,o,a)
local i=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if o or a then
local n=i.time()
while true do
if a and i.difftime(i.time(),n)>=a then
e.kill(t,e.const.SIGTERM)
return 1
end
if o then
local e=s:read(2048)
if e and#e>0 then
o(e)
end
end
local i,n,t=e.waitpid(t,"nohang")
if i and n=="exited"then return t end
if not o and a then e.nanosleep(1)end
end
else
local e,t,a=e.waitpid(t)
return e and t=="exited"and a
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(h,r,nil)
e.stdout:close()
i.exit(1)
end
end
function compare_versions(a,e,t)
local o=table
if not a then a=""end
if not t then t=""end
local i=util.split(a,"[%.%-]",nil,true)
local a=util.split(t,"[%.%-]",nil,true)
local t=o.getn(i)
local o=o.getn(a)
if(t<o)then t=o end
for o=1,t,1 do
local t=tonumber(i[o]or 0)or 0
local a=tonumber(a[o]or 0)or 0
if e=="~="and(t~=a)then return true end
if(e=="<"or e=="<=")and(t<a)then return true end
if(e==">"or e==">=")and(t>a)then return true end
if(t~=a)then return false end
end
return not(e=="<"or e==">")
end
local function s()
local e=nixio.uname().machine or""
if not OPENWRT_ARCH and fs.access("/usr/lib/os-release")then
OPENWRT_ARCH=sys.exec("echo -n $(grep 'OPENWRT_ARCH' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
if OPENWRT_ARCH==""then OPENWRT_ARCH=nil end
end
if not DISTRIB_ARCH and fs.access("/etc/openwrt_release")then
DISTRIB_ARCH=sys.exec("echo -n $(grep 'DISTRIB_ARCH' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
if DISTRIB_ARCH==""then DISTRIB_ARCH=nil end
end
if e:match("^i[%d]86$")then
e="x86"
elseif e:match("armv5")then
e="armv5"
elseif e:match("armv6")then
e="armv6"
elseif e:match("armv7")then
e="armv7"
end
if OPENWRT_ARCH or DISTRIB_ARCH then
if e=="mips"then
if OPENWRT_ARCH and OPENWRT_ARCH:match("mipsel")=="mipsel"
or DISTRIB_ARCH and DISTRIB_ARCH:match("mipsel")=="mipsel"then
e="mipsel"
end
elseif e=="armv7"then
if OPENWRT_ARCH and not OPENWRT_ARCH:match("vfp")and not OPENWRT_ARCH:match("neon")
or DISTRIB_ARCH and not DISTRIB_ARCH:match("vfp")and not DISTRIB_ARCH:match("neon")then
e="armv5"
end
end
end
return util.trim(e)
end
function parseURL(e)
if not e or e==""then
return nil
end
local t="^(%w+)://"
local a=e:match(t)
if not a then
return nil
end
local e=e:sub(#a+4)
local t="^([^@]+)@"
local t=e:match(t)
local o,i
if t then
o,i=t:match("^([^:]+):([^:]+)$")
e=e:sub(#t+2)
end
local t,e=e:match("^([^:]+):(%d+)$")
if not t or not e then
return nil
end
return{
protocol=a,
username=o,
password=i,
host=t,
port=tonumber(e)
}
end
local n={
x86_64="amd64",
x86="386",
aarch64="arm64",
mips="mips",
mipsel="mipsle",
armv5="arm.*5",
armv6="arm.*6[^4]*",
armv7="arm.*7",
armv8="arm64"
}
local function u(e)
local t=require"luci.jsonc"
local a,e=curl_logic(e,nil,curl_args)
if a~=0 or e==""then return{}end
return t.parse(e)or{}
end
local function h(e)
local t=get_app_path(e)or""
if t==""then
return{
code=1,
error=i18n.translatef("You did not fill in the %s path. Please save and apply then update manually.",e)
}
end
return{
code=0,
app_path=t
}
end
function to_check(e,a)
local o=h(a)
if o.code~=0 then
return o
end
if not e or e==""then e=s()end
local e=t[a].file_tree[e]or n[e]or""
if e==""then
return{
code=1,
error=i18n.translate("Can't determine ARCH, or ARCH not supported.")
}
end
local i=get_app_version(a)
local n=string.format(t[a].match_fmt_str,e)
local e=u(t[a]:get_url())
if#e>0 then
e=e[1]
end
if e.tag_name==nil then
return{
code=1,
error=i18n.translate("Get remote version info failed.")
}
end
local o=e.tag_name
if t[a].remote_version_str_replace then
o=o:gsub(t[a].remote_version_str_replace,"")
end
local t=compare_versions(i:match("[^v]+"),"<",o:match("[^v]+"))
if not t then
return{
code=0,
local_version=i,
remote_version=o
}
end
local t={}
for a,e in ipairs(e.assets)do
if e.name and e.name:match(n)then
t=e
break
end
end
if not t.browser_download_url then
return{
code=1,
local_version=i,
remote_version=o,
html_url=e.html_url,
data=t,
error=i18n.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
has_update=true,
local_version=i,
remote_version=o,
html_url=e.html_url,
data=t
}
end
function to_download(e,a,n)
local o=h(e)
if o.code~=0 then
return o
end
if not a or a==""then
return{code=1,error=i18n.translate("Download url is required.")}
end
sys.call("/bin/rm -f /tmp/"..e.."_download.*")
local o=util.trim(util.exec("mktemp -u -t "..e.."_download.XXXXXX"))
if n then
local e=r("/tmp")
if tonumber(n)>tonumber(e)then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
end
local s,n=curl_logic(a,o,curl_args)
n=s==0
if not n then
i("/bin/rm",{"-f",o})
return{
code=1,
error=i18n.translatef("File download failed or timed out: %s",a)
}
end
return{code=0,file=o,zip=t[e].zipped}
end
function to_extract(e,a,o)
local o=h(e)
if o.code~=0 then
return o
end
if not a or a==""or not fs.access(a)then
return{code=1,error=i18n.translate("File path required.")}
end
local o
if t[e].zipped then
if not t[e].zipped_suffix or t[e].zipped_suffix=="zip"then
o="unzip"
end
if t[e].zipped_suffix and t[e].zipped_suffix=="tar.gz"then
o="tar"
end
if o then
if sys.exec("echo -n $(command -v %s)"%{o})==""then
i("/bin/rm",{"-f",a})
return{
code=1,
error=i18n.translate("Not installed %s, Can't unzip!"%{o})
}
end
end
end
sys.call("/bin/rm -rf /tmp/"..e.."_extract.*")
local s=d(a)
local n=r("/tmp")
if n<=0 or n<=s then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
local n=util.trim(util.exec("mktemp -d -t "..e.."_extract.XXXXXX"))
local s={}
if o then
if o=="unzip"then
local t=sys.exec("echo -n $(command -v unzip)")
i(t,{"-o",a,e,"-d",n},function(e)s[#s+1]=e end)
elseif o=="tar"then
local o=sys.exec("echo -n $(command -v tar)")
if t[e].zipped_suffix=="tar.gz"then
i(o,{"-zxf",a,"-C",n},function(e)s[#s+1]=e end)
sys.call("/bin/mv -f "..n.."/*/"..t[e].name:lower().." "..n)
end
end
end
local e=util.split(table.concat(s))
i("/bin/rm",{"-f",a})
return{code=0,file=n}
end
function to_move(e,s)
local h=h(e)
if h.code~=0 then
return h
end
local a=h.app_path
local o=s
local n="/bin/rm -rf /tmp/"..e.."_download.*"
if fs.stat(s,"type")=="dir"then
o=s.."/"..t[e].name:lower()
n="/bin/rm -rf /tmp/"..e.."_extract.*"
end
if not s or s==""then
sys.call(n)
return{code=1,error=i18n.translate("Client file is required.")}
end
local t=get_app_version(e,o)
if t==""then
sys.call(n)
return{
code=1,
error=i18n.translate("The client file is not suitable for current device.")..e.."__"..o
}
end
local t=sys.call('pgrep -af "passwall/.*'..e..'" >/dev/null')
if t==0 then
sys.call("/etc/init.d/passwall stop")
end
local s=0
if fs.access(a)then
s=d(a)
end
local u=d(o)
local d=l(a)
local e=r(d)
if e>0 then
e=e+s
if u>e then
sys.call(n)
return{code=1,error=i18n.translatef("%s not enough space.",d)}
end
end
h=i("/bin/mv",{"-f",o,a},nil,command_timeout)==0
sys.call(n)
if t==0 then
sys.call("/etc/init.d/passwall restart >/dev/null 2>&1 &")
end
if not h or not fs.access(a)then
return{
code=1,
error=i18n.translatef("Can't move new file to path: %s",a)
}
end
return{code=0}
end
function get_version()
return sys.exec("echo -n $(opkg list-installed luci-app-passwall |awk '{print $3}')")
end
function to_check_self()
local t="https://raw.githubusercontent.com/xiaorouji/openwrt-passwall/main/luci-app-passwall/Makefile"
local e="/tmp/passwall_makefile"
local a,t=curl_logic(t,e,curl_args)
t=a==0
if not t then
i("/bin/rm",{"-f",e})
return{
code=1,
error=i18n.translatef("Failed")
}
end
local t=get_version()
local e=sys.exec("echo -n $(grep 'PKG_VERSION' /tmp/passwall_makefile|awk -F '=' '{print $2}')")
local a=compare_versions(t,"<",e)
if not a then
return{
code=0,
local_version=t,
remote_version=e
}
end
return{
code=1,
has_update=true,
local_version=t,
remote_version=e,
error=i18n.translatef("The latest version: %s, currently does not support automatic update, if you need to update, please compile or download the ipk and then manually install.",e)
}
end
function is_js_luci()
return sys.call('[ -f "/www/luci-static/resources/uci.js" ]')==0
end
function set_apply_on_parse(e)
if is_js_luci()==true then
e.apply_on_parse=false
e.on_after_apply=function(e)
if e.redirect then
os.execute("sleep 1")
luci.http.redirect(e.redirect)
end
end
end
end
function luci_types(h,o,e,n,a)
local i={}
for t,s in pairs(e.fields)do
if t:find(a)==1 then
if not e.fields[t].not_rewrite then
if e.fields[t].rewrite_option then
if not i[e.fields[t].rewrite_option]then
i[e.fields[t].rewrite_option]=1
else
i[e.fields[t].rewrite_option]=i[e.fields[t].rewrite_option]+1
end
end
e.fields[t].cfgvalue=function(t,i)
if t.rewrite_option then
return o:get(i,t.rewrite_option)
else
if t.option:find(a)==1 then
return o:get(i,t.option:sub(1+#a))
end
end
end
e.fields[t].write=function(t,s,i)
if e.fields["type"]:formvalue(h)==n then
if t.rewrite_option then
o:set(s,t.rewrite_option,i)
else
if t.option:find(a)==1 then
o:set(s,t.option:sub(1+#a),i)
end
end
end
end
e.fields[t].remove=function(t,s)
if e.fields["type"]:formvalue(h)==n then
if t.rewrite_option and i[t.rewrite_option]==1 then
o:del(s,t.rewrite_option)
else
if t.option:find(a)==1 then
o:del(s,t.option:sub(1+#a))
end
end
end
end
end
local a=e.fields[t].deps
if#a>0 then
for e,t in ipairs(a)do
a[e]["type"]=n
end
else
e.fields[t]:depends({type=n})
end
end
end
end
